import sys
import time
import string

from gtk import *
#from GDK import *
import libglade
import vjbox
import pwd
import posix

username=pwd.getpwuid(posix.getuid())[0] 
box=vjbox.vj("localhost",4711,username)
widgets = libglade.GladeXML('mailgt.glade')
current_board="tmp"


class boardlistClass:
    def __init__(self):
        self.listW=widgets.get_widget("clist2")
        self.connect=self.listW.connect
        self.load_list()

    def slot_selection_changed(self,x):
        pass
            
    def load_list(self):
        data=box.boardlist()
        spalte=0
        data2=[]
        self.listW.clear()
        for line in data:
            [bo,typ,anzahl]=string.split(line)[:3]
            data2.append(bo)
            self.listW.append([bo])

class articlelistClass:
    def __init__(self):
        self.listW=widgets.get_widget("clist1")
        self.connect=self.listW.connect
        

    def load_list(self,board):
        data=box.list2(board,1,9999)
        self.listW.clear()
        for l in data:
            self.listW.append([l[8],l[3],time.strftime("%a,%d.%b,%H:%M",time.localtime(string.atoi(l[4]))),l[5],l[9]])
                        

    def slot_fill_list(self,clist,row,column,event):
        global current_board
        current_board=clist.get_text(row,column)
        self.load_list(current_board)
 
class textwinClass:
    def __init__(self):
        self.textW=widgets.get_widget("text1")
        self.textW.set_editable(FALSE)
        self.connect=self.textW.connect
        
    def slot_show_text(self,clist,row,column,event):
        message=box.read(current_board,row+1)
        self.textW.set_point(0)
        self.textW.forward_delete(self.textW.get_length())
        self.textW.freeze()
        for line in message:
            self.textW.insert(None,None,None,line+"\n")
        self.textW.thaw()

class sendmessageClass:
    def __init__(self):
        self.dlgW=widgets.get_widget("postwindow")
        self.textW=widgets.get_widget("messageinput")
        self.textW.set_editable(TRUE)
        self.destcallW=widgets.get_widget("entry1")
        self.distribW=widgets.get_widget("entry2")
        self.subjectW=widgets.get_widget("entry3")
        widgets.get_widget("button6").connect("clicked",
                                              self.slot_ok)
        widgets.get_widget("button7").connect("clicked",
                                              self.slot_cancel)
        self.textW.set_point(0)
        self.textW.forward_delete(self.textW.get_length())
        
    def __del__(self):
        print "deschdruggder"

    def slot_ok(self,button):
        if (self.destcallW.get_text()==""):
            print "need destcall"
            return
        if (self.subjectW.get_text()==""):
            print "need subject"
            return
        mess=[self.textW.get_chars(0,-1)]
        box.putmail(username,self.destcallW.get_text(),
                    self.distribW.get_text(),self.subjectW.get_text(),
                    mess)
        tl.refresh()
        self.dlgW.hide()
 
    def slot_cancel(self,button):
        self.dlgW.hide()

    def show(self):
        self.dlgW.show()

class aboutClass:
    def __init__(self):
        widgets.get_widget("versionlabel").set_text(string.join(box.version()))
        widgets.get_widget("button9").connect("clicked",self.done)
        
    def done(self,b):
        widgets.get_widget("dialog3").hide()
    def show(self,menu):
        widgets.get_widget("versionlabel").set_text(string.join(box.version()))

        widgets.get_widget("dialog3").show()
    
class toplevel:
    def __init__(self,t):
        self.w=widgets.get_widget("window1")
        self.w.set_title(t)
        self.boardlistI=boardlistClass()
        self.articlelistI=articlelistClass()
        self.textwinI=textwinClass()
        self.boardlistI.connect("select_row",
                                self.articlelistI.slot_fill_list)
        self.articlelistI.connect("select_row",
                                  self.textwinI.slot_show_text)
#        self.sw=widgets.get_widget("postwindow")
        self.sendmessageI=sendmessageClass()
        self.abtI=aboutClass()
        widgets.get_widget("about").connect("activate",
                                            self.abtI.show)
        widgets.get_widget("exit1").connect("activate",
                                            self.slot_exit_menu)
        widgets.get_widget("send_message1").connect("activate",
                                                    self.slot_send_message_menu)
        

    def run(self):
        mainloop()

    def refresh(self):
        self.boardlistI.load_list()
        self.articlelistI.load_list(current_board)
                                          

    def slot_exit_menu(self,menu):
        mainquit()

    def slot_send_message_menu(self,menu):
        self.sendmessageI.show()

    def slot_board_select(self,selection):
        pass


title="%s@%s"  % (username,box.boxname)
tl=toplevel(title)
tl.run()
sys.exit()













